package org.fuseri.moduleexercise.question;

import jakarta.persistence.EntityNotFoundException;
import org.fuseri.moduleexercise.exercise.Exercise;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import java.util.HashSet;
import java.util.Optional;

import static org.mockito.ArgumentMatchers.anyLong;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

@SpringBootTest
public class QuestionServiceTest {



    @MockBean
    QuestionRepository repository;

    @Autowired
    QuestionService service;

    Exercise exercise;
    Question question;
    Question question1;

    @BeforeEach
    void setup() {
        exercise = new Exercise("idioms", "exercise on basic idioms",2,1L,new HashSet<Question>());
        question = new Question("text",new HashSet<>(),exercise);
        question1 = new Question("text2",new HashSet<>(),exercise);
    }


    @Test
    void create() {
        when(repository.save(question)).thenReturn(question);
        Question result = service.create(question);
        Assertions.assertEquals(question, result);
        verify(repository).save(question);
    }

    @Test
    void notFound() {
        when(repository.findById(anyLong())).thenReturn(Optional.empty());

        Assertions.assertThrows(EntityNotFoundException.class, () -> service.find(anyLong()));
    }

    @Test
    void find() {
        when(repository.findById(anyLong())).thenReturn(Optional.of(question));

        Question result = service.find(anyLong());

        Assertions.assertEquals(question, result);
        verify(repository).findById(anyLong());
    }

}
